
ShapeDialog = class(function (self)
   local xmlResource = wx.wxXmlResource()
   xmlResource:InitAllHandlers()
   xmlResource:Load(sc.GetMyPath().."ShapeDialog.xrc")
   self.dlg = xmlResource:LoadDialog(auiMgr:GetManagedWindow(), "ShapeDialog")
   if not self.dlg then
      wx.wxMessageBox("Error loading xrc resources!",
                     "Options",
                     wx.wxOK + wx.wxICON_EXCLAMATION,
                     wx.NULL)
      return -- quit
   end
   self.tree = self.dlg:FindWindow(xmlResource.GetXRCID("ID_DIRTREE")):DynamicCast("wxTreeCtrl")
   self.images = wx.wxImageList(32,32,true,0)
   self.tree:AssignImageList(self.images)
   local path = sc.GetMyPath()
   path = path .. "shapes"
   self:RecurseDirs(path, self.tree:AddRoot(""))
--   self.tree:Connect(wx.wxEVT_COMMAND_TREE_SEL_CHANGED, shapeDialog.OnTreeSelect)
   self.dlg:Show(false)
   self.dlg:Centre()
end)

function ShapeDialog:GetName(name)
   local tok = wx.wxStringTokenizer(name, "\\/")
--   local sel = self.tree:GetSelection()
   local id = self.tree:GetRootItem()
   while tok:HasMoreTokens() do
      local tag = tok:GetNextToken()
      local cookie
      local item = id
      id, cookie = self.tree:GetFirstChild(item)
      local found = false
      while id:IsOk() do
         if(self.tree:GetItemText(id) == tag) then
            found = true
            break
         end
         id, cookie = self.tree:GetNextChild(item, cookie)
      end
      if not found then return end --path not found
   end
--[[   if(id:op_eq(sel)) then
      return true
   end
   shapeDialog.ItemSelected(id)]]
   self.tree:SelectItem(id)   
   if(self.dlg:ShowModal() ~= wx.wxID_OK) then return end
   

--[[   hintBitmap:SetBitmap(wx.wxNullBitmap)
   local cfg = wx.wxConfigBase.Get(false)
   if(curItem and string.len(curItem) > 0) then
      cfg:SetPath("/plugins/shape/" .. curItem)
      SaveConfig(cfg)
   end
   curItem = ""
   partName = self.tree:GetItemText(id)]]
   name = nil
   id = self.tree:GetSelection()
   while id:IsOk() and self.tree:GetItemText(id) ~= "" do
      if name then
         name = self.tree:GetItemText(id) .. "/" .. name
      else
         name = self.tree:GetItemText(id)
      end
      id = self.tree:GetItemParent(id)
   end
   return name
--[[   
   curPath = sc.GetMyPath() .. "shapes/" .. curItem
   local file = curPath .. "main.lua"
   statusPanel:GetSizer():Clear(true)
   values = {}
   lists = {}
   shape = nil
   local err
   local shapeFunc
   if not wx.wxFileExists(file) then
      return
   end
   shapeFunc = assert(loadfile(file))
   shapeFunc()
   if not shape then return end

   cfg:SetPath("/plugins/shape/" .. curItem)
   LoadConfig(cfg)
   CreateControls()
   for name, list in pairs(lists) do
      FillGrid(list)
   end
]]
   
end

function ShapeDialog:RecurseDirs(path, parentItem)
   local dir = wx.wxDir(path);
   local fileName
   local a
   a,fileName = dir:GetFirst("*",wx.wxDIR_DIRS)
   while fileName ~= "" do
      local img = -1;
      local dirPath = path .. "/" .. fileName
      local png = wx.wxBitmap(dirPath .. "/icon.png")
      if(png:Ok()) then
         if(png:GetWidth() ~= 32 or png:GetHeight() ~= 32) then
            local image = png:ConvertToImage()
            image:Rescale(32,32)
            png = wx.wxBitmap(image)
         end
      
         img = self.images:Add(png)
      end
      local id = self.tree:AppendItem(parentItem, fileName, img)
           
      self:RecurseDirs(dirPath, id)
      a,fileName = dir:GetNext()
   end
end

--[[
function ShapeDialog:OnTreeSelect(evt)
   self:ItemSelected(evt:GetItem())
--   OnValue(evt)
end
]]
--[[
function ShapeDialog:SelectTree(path)
   local data = tempObj:GetGroupData()
   local a
   local id
   a,name = data:Read("name","")
   local pth = sc.GetMyPath().. "shapes/" .. name
   if not wx.wxFileExists(pth .. "main.lua") then
      wx.wxLogMessage("Shape '" .. name .. "' does not exist")
      return false
   end
   local tok = wx.wxStringTokenizer(name, "\\/")
   local sel = self.tree:GetSelection()
   local id = self.tree:GetRootItem()
   while tok:HasMoreTokens() do
      local tag = tok:GetNextToken()
      local cookie
      local item = id
      id, cookie = self.tree:GetFirstChild(item)
      local found = false
      while id:IsOk() do
         if(self.tree:GetItemText(id) == tag) then
            found = true
            break
         end
         id, cookie = self.tree:GetNextChild(item, cookie)
      end
      if not found then return end --path not found
   end
   if(id:op_eq(sel)) then
      return true
   end
   shapeDialog.ItemSelected(id)
--   self.tree:Enable(false)
   self.tree:SelectItem(id)
   return true
end
]]

